<script lang="ts">
  import clickOutside from '@svelte-common/hooks/useClickOutside.js';
  import Accordion from '@svelte-ui/accordion/Accordion.svelte';
  import { categories } from '../games.js';
  import { currentCategory } from '../stores/game-store.js';

  $: current = $currentCategory || categories[0].category;

  const isOpened = [false, false, false];

  const onToggle = (idx: number, data: Record<string, string>) => {
    isOpened.forEach(() => {
      isOpened[idx] = data.detail.isOpen;
    });
  };

  const onLinkClick = (category: string) => {
    currentCategory.update(() => category);
  };
</script>

<div class="top-container">
  <div use:clickOutside={() => (isOpened[0] = false)}>
    <Accordion
      on:toggle={onToggle.bind(null, 0)}
      open={isOpened[0]}>
      <div
        slot="accordion-tab"
        class="tab">
        <h4>{current}</h4>
        <img
          src="~/ui/arrow-forward.svg"
          class:open={isOpened[0]} />
      </div>
      <ul slot="accordion-content">
        {#each categories as data}
          <li>
            <a
              href={data.link}
              on:click={() => onLinkClick(data.category)}>{data.category}</a>
          </li>
        {/each}
      </ul>
    </Accordion>
  </div>
  <!-- <span class="right"><Search /></span> -->
</div>

<style lang="postcss">
  .top-container {
    position: sticky;
    z-index: 1;
    top: 0;
    display: flex;
    width: 100%;
    justify-content: space-between;
    background-color: bisque;
    padding-inline: var(--content-margin);

    div:first-child {
      width: 100%;
    }
  }

  .tab {
    position: relative;
    display: flex;
    height: 40px;
    align-items: center;
    justify-content: space-between;

    img {
      position: absolute;
      right: 0;
      width: 20px;
      transform: rotate(90deg);
      transition: transform 0.3s ease;

      &.open {
        transform: rotate(-90deg);
      }
    }
  }

  .right {
    right: 0;
  }
</style>
